SET ECHO OFF
SET VERIFY OFF
SET FEEDBACK OFF
SET DEFINE '&'
SET SCAN ON
SET TERMOUT ON

spool bld_db.lst

--Tell the user what we are about to do, and confirm
--that the user wishes to proceed.
PROMPT
PROMPT This script creates the tables and sample data needed
PROMPT to run the examples in the SQL*Plus book.
PROMPT
ACCEPT continue_flag CHAR PROMPT 'Do you wish to continue (Y/N)?'

--Execute the appropriate command file based on the
--user's response. Note that the Y/N response is used to form
--the name of the next file we should execute.
--TERMOUT is set off so that the user does not
--see any errors caused by the file not existing.
define bld_db1_flag = 'n'
SET TERMOUT OFF
@@bld_db1&continue_flag
SET TERMOUT ON

--If one the BLD_DB1X files was not executed, then
--bld_db1_flag will still be N. In that case we display an
--error message.
SET SERVEROUTPUT ON
PROMPT
BEGIN
  IF '&BLD_DB1_FLAG' = 'n' THEN
    DBMS_OUTPUT.PUT_LINE('You must answer either Y or N.');
    DBMS_OUTPUT.PUT_LINE('Please rerun the command file and answer correctly.');
  END IF;
END;
/

PROMPT
PROMPT Thank-you for loading the sample data!
PAUSE Please press ENTER.

spool off

